#include <png.h>
#include <stdio.h>
#include <stdlib.h>

void png_error_fn(int error)
{
printf("Error reading png\n");
exit(1);
}

void png_warning_fn(int warning)
{
printf("Warning reading png\n");
}

void get_png_info(char *file,int *width, int *height, char **palette, int *palette_size)
{
    FILE *fp;
    png_structp png_ptr;
    png_infop info_ptr;
    png_ptr = png_create_read_struct(PNG_LIBPNG_VER_STRING, NULL,
    				     (voidp)png_error_fn, (voidp)png_warning_fn);
    fp=fopen(file,"rb");
    if (!png_ptr) return;

    info_ptr = png_create_info_struct(png_ptr);
    if (!info_ptr)
    {
    png_destroy_read_struct(&png_ptr,
    (png_infopp)NULL, (png_infopp)NULL);
    return;
    }
    png_init_io(png_ptr, fp);
    png_read_info(png_ptr, info_ptr);
    *width=png_get_image_width(png_ptr,info_ptr);
    *height=png_get_image_height(png_ptr,info_ptr);
    png_get_PLTE(png_ptr, info_ptr, (png_color **)palette,
                         palette_size);
    fclose(fp);
}

void get_png_data(char *file, void *data)
{
    FILE *fp;
    int width,height,i;
    char **png_row_pointers;
    png_structp png_ptr;
    png_infop info_ptr;
    png_ptr = png_create_read_struct
    (PNG_LIBPNG_VER_STRING, NULL,
    (voidp)png_error_fn, (voidp)png_warning_fn);
    fp=fopen(file,"rb");
    if (!png_ptr) return;

    info_ptr = png_create_info_struct(png_ptr);
    if (!info_ptr)
    {
    png_destroy_read_struct(&png_ptr,
    (png_infopp)NULL, (png_infopp)NULL);
    return;
    }
    png_init_io(png_ptr, fp);
    png_read_info(png_ptr, info_ptr);
    width=png_get_image_width(png_ptr,info_ptr);
    height=png_get_image_height(png_ptr,info_ptr);
    png_row_pointers=(char**)malloc(height*sizeof(char*));
    for(i=0;i<height;i++)
      {
      png_row_pointers[i]=data+i*width;
      }
    png_read_image(png_ptr,(png_bytepp)png_row_pointers);
    fclose(fp);
}
