/* GGL - GPUL Game Library
 * Copyright (C) 1998 G.P.U.L. (Group of programmers and users of Linux)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __GGLJOYDEV_H__
#define __GGLJOYDEV_H__

#include <glib.h>
#include <ggl/gglbase.h>
#include <ggl/ggldevice.h>
#include <ggi/ggi.h>

#define GGL_JOYDEV(joydev) (GGL_CAST(joydev,GglJoyDev*,GGLJOYDEV))

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef struct _GglJoyDev GglJoyDev;

struct _GglJoyDev{
  GglDevice device;
  int id;
  GglVisual *visual; /* The visual on which we receive events */  
};

/* Constructors */
GglJoyDev*	ggl_joydev_new		(GglVisual *visual);

void		ggl_joydev_init		(GglJoyDev *joydev,
					 GglVisual *visual);

void		ggl_joydev_finalize	(GglJoyDev *joydev);

void		ggl_joydev_dispose	(GglJoyDev *joydev);

#ifdef __cplusplus
      }
#endif /* __cplusplus */

#endif /* __GGLJOYDEV_H__ */
