/* GGL - GPUL Game Library
 * Copyright (C) 1998 G.P.U.L. (Group of programmers and users of Linux)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __GGLSERVER_H__
#define __GGLSERVER_H__

#include <ggl/gglbase.h>

#define GGL_SERVER(server) (GGL_CAST(server,GglServer*,GGLSERVER))

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef struct _GglServer GglServer;

struct _GglServer{
  GglBase base;         /* Base class */
  int id;               /* Class Identifier */
};

/* Constructors */
GglServer *	ggl_server_new		(void);
void		ggl_server_init		(GglServer*	server);	
void		ggl_server_wait		(int	max,
					 int	timeout,
					 int	local_port);
void		ggl_server_finalize	(GglServer*	server);
void		ggl_server_dispose	(GglServer*	server);
					
#ifdef __cplusplus
      }
#endif /* __cplusplus */

#endif /* __GGLSERVER_H__ */

