/* GGL - GPUL Game Library
 * Copyright (C) 1998 G.P.U.L. (Group of programmers and users of Linux)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __GGLSOCKET_H__
#define __GGLSOCKET_H__

#include <ggl/gglbase.h>
#include <glib.h>

#define GGL_SOCKET(socket) (GGL_CAST(socket,GglSocket*,GGLSOCKET))

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef struct _GglSocket GglSocket;

struct _GglSocket{
  GglBase base;         /* Base class */
  int id;               /* Class Identifier */

  int status;     	/* Internal status */
  GList *net_event_list;/* List of attached NetEvents */
  char *buffer;		/* Socket buffer */
};

/* Constructors */
GglSocket *	ggl_socket_new	(void);
void		ggl_socket_init	(GglSocket *	socket);
void 		ggl_socket_flush(void);
void 		ggl_socket_kill	(void);
int		ggl_socket_send	(int	obj_id,
				 void *	data,
				 int 	size_data);
GList *		ggl_socket_net_event_list	(void);
GglDescriptor *	ggl_socket_add	(int	obj_id,
				 void *	method);
void		ggl_socket_finalize	(GglSocket *	socket);
void		ggl_socket_dispose	(GglSocket *	socket);

#ifdef __cplusplus
      }
#endif /* __cplusplus */

#endif /* __GGLSOCKET_H__ */

