/* GGL - GPUL Game Library
 * Copyright (C) 1998 G.P.U.L. (Group of programmers and users of Linux)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __GGLTYPES_H__
#define __GGLTYPES_H__


typedef enum {
  GGLBASE,
  GGLFRAME,
  GGLANIM,
  GGLSPRITE,
  GGLSTATIC,
  GGLBACKGROUND,
  GGLSCREEN,
  GGLLAYER,
  GGLGRAPHIC,
  GGLNETWORK,
  GGLCLIENT,
  GGLSERVER,
  GGLSOCKET,
  GGLUDPSOCKET,
  GGLNETEVENT,
  GGLVISUAL,
  GGLCOLOR,
  GGLMASK,
  GGLPALETTE,
  GGLDEVICE,
  GGLOBSERVER,
  GGLKEYDEV,
  GGLJOYDEV,
  GGLMOUSEDEV,
  GGLTIMEOUT,
  GGLFILLER,
  GGLVIDEO,
  GGLARBITER,
  GGLGC,
  GGL_LAST_CLASS
} GglType;

typedef enum {
    GGL_1BIT,
    GGL_4BIT,
    GGL_8BIT,
    GGL_15BIT,
    GGL_16BIT,
    GGL_24BIT,
    GGL_32BIT
} GglDepth;

typedef enum {
    GGL_AXIS_EVENT=0,
    GGL_BUTTON_EVENT=1,
    GGL_COLLISION_EVENT=2,
    /* Third one mustn't be used never! */
    GGL_FINISH_EVENT=4
    /* Never more than 32! */
} GglEventType;

typedef enum {
    GGL_KEYBOARD,
    GGL_JOYSTICK,
    GGL_MOUSE,
    GGL_ARBITER
} GglDeviceType;

typedef enum {
    GGL_EVMASK_NONE=		0,

    GGL_EVMASK_AXIS= 		1 << GGL_AXIS_EVENT,
    GGL_EVMASK_BUTTON=		1 << GGL_BUTTON_EVENT,
    GGL_EVMASK_ANY_COLLISION=	1 << GGL_COLLISION_EVENT,
    GGL_EVMASK_OWN_COLLISION=	2 << GGL_COLLISION_EVENT,
    GGL_EVMASK_FINISH=		1 << GGL_FINISH_EVENT,
    
    GGL_EVMASK_ALL=		0xFFFFFFFF
} GglEventMask;


typedef void (*GglFunc)(void *data);

typedef struct {
  GglFunc callback;
  void *data;
} GglCallback;

typedef enum {
  GGL_CLIPPING,
  GGL_ANTIALIAS
} Ggl3DProperty;

#endif /* __GGLTYPES_H__ */
